/*  graph2wav.c */

/*
  $B%0%i%U%G!<%?$+$i(Bwav$B%U%!%$%k$N:n@.(B

  16bit	$B%9%F%l%*(B
*/

#include<stdio.h>
#include<stdlib.h> 

#define MAXSIZE 9999
#define BUFSIZE 100
#define NUMBER  1

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	$B%U%!%$%k%5%$%:!J8e$G7W;;!K(B	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	$B%j%K%"(BPCM$B!J2;$r5-O?$9$k7A<0!K(B	*/
	
  p->nCh = 2;		/*	$B%9%F%l%*(B	*/
  p->nRate = 44100;	/*	$B%5%s%W%j%s%0<~GH?t(B
						$B!JC10L;~4VEv$?$j$N%G!<%?$N:N<h2s?t!K(B	*/
  p->nSpeed = 176400;	/*	$BJ?6Q%G!<%?B.EY(B	*/
  p->nBlockSize = 4;	/*	$B%V%m%C%/%5%$%:(B	*/
  p->nBitsParSample = 16;	/*	$BNL;R2=%S%C%H?t(B	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
	
  p->nDataBytes = 176400L*5L;	/*	$B%G!<%?%5%$%:(B	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	$B%U%!%$%k%5%$%:(B	*/
}

unsigned char function(double x1, double x2, int i );


int		main( int argc, char* argv[])
{
  WaveHeaderType	h;
  int  i, j,k,l,n,s;
  long	x;
  char	c;
  double data[MAXSIZE];
  FILE*	fp;
	
  fp = fopen( "graph_1.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	
	
  n = getdata(data);  /* data[]$B$K3JG<$9$k(B */
  k = 176400/n;       /* 1$B6h4V$"$?$j$N%5%s%W%j%s%0?t(B */
  l = atoi(argv[2]); 
	
  if(argc == 3 && strcmp(argv[1],"--second")==0){
	if((l > 5) | (l < 1)){
	  printf("1 - 5 second only.\n");
	  return -1;
	}else{
	  for( s = 0; s < l; s++ ){
		for ( j = 0; j < n; j ++ ){
		  for( i = k*j; i < k*(j+1); i++ ) {
		    c = function( data[j], data[j+1], i );
		    fwrite( &c, sizeof(c), 1, fp );
		  }
		}
	  }
	  fclose( fp );
	  return 0 ;
	}
  }else{
	printf("miss type. sample: ./a.out --second 1 < graph.txt\n");
	return -1;
  }
}



unsigned char function( double x1, double x2, int i)
{

  unsigned char f;
  f =32*(x1 + (x2 - x1 )*i/176400);

  return f;
}



int getdata(double s[])       /* $B%G!<%?$rFI$_9~$`(B */
{
  int i = 0;
  int c;
  char buf[BUFSIZE];

  do{
    c =  getop(buf);
    if(c ==NUMBER){
      s[i]=atof(buf);
      /*   printf("%f\n",s[i]); */
      i++;
    }
  }while(c != -1);
  s[i]=atof(buf);
  /*  printf("%f\n",s[i]); */
  
  return i;
}





int getop(char s[])          /* $BMWAG$rFI$_9~$`(B */
{
  int i = 0;
  char  c;
  do{
    c = getchar();
    s[i] = c;
    i++;
  }
  while( c !=',' && c != EOF );
  if (c == ','){
    return NUMBER;
  }
  if (c == EOF){
    return -1;
  }
}


/* graph2wav.c  end */
