/*  bessel_4.c */

/*
  ߷ˤwavեκ

  16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*7L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char bessel( int i, double a, double b, double lambda );


int		main()
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double lambda1 = 2.4048;    /* besselؿθͭ */
  double lambda2 = 5.5201; 
  double lambda3 = 8.6537;
  double lambda4 = 11.7915;
  double lambda5 = 14.9309;
  /*    double lambda6 = 18.0711; */


  double a1 = 20.134;     /* ܲʬʬۡʰʲŬ*/
  double b1 = -15.541;
  double a2 = 0.215;
  double b2 = 0.134;
  double a3 = 0.224;
  double b3 = -0.134;
  double a4 = -0.221;
  double b4 = -0.152;
  double a5 = -1.432;
  double b5 = 1.241;

  fp = fopen( "bessel_4.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 7 */
  for( i = 0; i < 176400*1; i++ ) {
	c = bessel( i, a1, b1, lambda1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = bessel( i, a1, b1, lambda1 ) 
	  + bessel( i, a2, b2, lambda2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for( i = 176400*2; i < 176400*3; i++ ) {
	c = bessel( i, a1, b1, lambda1 ) 
	  + bessel( i, a2, b2, lambda2 )
	  + bessel( i, a3, b3, lambda3 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*3; i < 176400*4; i++ ){
	c = bessel( i, a1, b1, lambda1 ) 
	  + bessel( i, a2, b2, lambda2 ) 
	  + bessel( i, a3, b3, lambda3 ) 
	  + bessel( i, a4, b4, lambda4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*4; i < 176400*7; i++ ){
	c = bessel( i, a1, b1, lambda1 ) 
	  + bessel( i, a2, b2, lambda2 ) 
	  + bessel( i, a3, b3, lambda3 ) 
	  + bessel( i, a4, b4, lambda4 ) 
	  + bessel( i, a5, b5, lambda5 );
	fwrite( &c, sizeof(c), 1, fp );
  }

  fclose( fp );

  return 0 ;
}

unsigned char bessel( int i, double a, double b, double lambda)
{
  int n;
  unsigned char f = 0;
  int v = 880;           /* Ȥ® */
  int r = 1;             /* Ⱦ */
    

  f = a * sin( lambda * (double)(i / 176400.0) * v ) 
	+ b * cos(lambda * (double)(i / 176400.0) * v );

  return f;
}


/* bessel_4.c  end */
