/*  Sierpinski_H1.c */

/*
	Sierpinski Gasketˤwavեκ

	16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
	char	cRiffHeader[4];
	long	nFileSize;
	char	cWaveHeader[4];
	char	cFmtChunk[4];
	long	nChunkSize;
	short	nFmtID;
	short	nCh;
	long	nRate;
	long	nSpeed;
	short	nBlockSize;
	short	nBitsParSample;
	char	cDataChunk[4];
	long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
	p->cRiffHeader[0] = 'R';
	p->cRiffHeader[1] = 'I';
	p->cRiffHeader[2] = 'F';
	p->cRiffHeader[3] = 'F';
	
	p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
	p->cWaveHeader[0] = 'W';
	p->cWaveHeader[1] = 'A';
	p->cWaveHeader[2] = 'V';
	p->cWaveHeader[3] = 'E';
	
	p->cFmtChunk[0] = 'f';
	p->cFmtChunk[1] = 'm';
	p->cFmtChunk[2] = 't';
	p->cFmtChunk[3] = ' ';
	
	p->nChunkSize = 16;
	
	p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
	p->nCh = 2;		/*	ƥ쥪	*/
	p->nRate = 44100;	/*	ץ󥰼ȿ
							ñ̻Υǡκμ	*/
	p->nSpeed = 176400;	/*	ʿѥǡ®	*/
	p->nBlockSize = 4;	/*	֥å	*/
	p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
	p->cDataChunk[0] = 'd';
	p->cDataChunk[1] = 'a';
	p->cDataChunk[2] = 't';
	p->cDataChunk[3] = 'a';
       
	p->nDataBytes = 176400L*6L;	/*	ǡ	*/
	
	p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char sierpinski( int i, double a, double b, double lambda );


int		main( int ac, char* av[])
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double lambda1 =  0.0000;    /* Sierpinski Gasketθͭ */
  double lambda2 = -1.6972;
  double lambda3 = -4.0000;
  double lambda4 = -5.3028; 


  double a1 = 3.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 3.156;
  double a2 = -5.077;
  double b2 = 5.536;
  double a3 = -4.00;
  double b3 = 8.025;
  double a4 = -6.077;
  double b4 = 3.134;

  fp = fopen( "sierpinski_H1.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 6 */
  for( i = 0; i < 176400*1; i++ ) {
	c = sierpinski( i, a1, b1, lambda1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*2; i < 176400*3; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 )
	  + sierpinski( i, a3, b3, lambda3 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*3; i < 176400*6; i++ ){
	c = sierpinski( i, a1, b1, lambda1 )
	  + sierpinski( i, a2, b2, lambda2 )
	  + sierpinski( i, a3, b3, lambda3 )
	  + sierpinski( i, a4, b4, lambda4 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  fclose( fp );

  return 0 ;
}

unsigned char sierpinski( int i, double a, double b, double lambda)
{
  int n;
  unsigned char f = 0;
  int v = 1000;           /* Ȥ® */
    

  f = a * sin( lambda * (double)(i / 176400.0) * v )
 + b * cos(lambda * (double)(i / 176400.0) * v );

	return f;
}


/* Sierpinski_H1.c  end */
