/*  Sierpinski_H3.c */

/*
  Sierpinski Gasketˤwavեκ

  16bit	ƥ쥪  ץǡ
*/

#include	<stdio.h>
#include	<math.h>

typedef	struct	tagWaveHeaderType	{
  char	cRiffHeader[4];
  long	nFileSize;
  char	cWaveHeader[4];
  char	cFmtChunk[4];
  long	nChunkSize;
  short	nFmtID;
  short	nCh;
  long	nRate;
  long	nSpeed;
  short	nBlockSize;
  short	nBitsParSample;
  char	cDataChunk[4];
  long	nDataBytes;
}	WaveHeaderType, * LpWaveHeaderType;


void	InitHeader( LpWaveHeaderType p )
{
  p->cRiffHeader[0] = 'R';
  p->cRiffHeader[1] = 'I';
  p->cRiffHeader[2] = 'F';
  p->cRiffHeader[3] = 'F';
	
  p->nFileSize = 0;	/*	ե륵ʸǷ׻	*/
	
  p->cWaveHeader[0] = 'W';
  p->cWaveHeader[1] = 'A';
  p->cWaveHeader[2] = 'V';
  p->cWaveHeader[3] = 'E';
	
  p->cFmtChunk[0] = 'f';
  p->cFmtChunk[1] = 'm';
  p->cFmtChunk[2] = 't';
  p->cFmtChunk[3] = ' ';
	
  p->nChunkSize = 16;
	
  p->nFmtID = 1;	/*	˥PCMʲϿ	*/
	
  p->nCh = 2;		/*	ƥ쥪	*/
  p->nRate = 44100;	/*	ץ󥰼ȿ
						ñ̻Υǡκμ	*/
  p->nSpeed = 176400;	/*	ʿѥǡ®	*/
  p->nBlockSize = 4;	/*	֥å	*/
  p->nBitsParSample = 16;	/*	̻Ҳӥåȿ	*/
	
  p->cDataChunk[0] = 'd';
  p->cDataChunk[1] = 'a';
  p->cDataChunk[2] = 't';
  p->cDataChunk[3] = 'a';
       
  p->nDataBytes = 176400L*20L;	/*	ǡ	*/
	
  p->nFileSize = p->nDataBytes + 44L - 8L;	/*	ե륵	*/
}

unsigned char sierpinski( int i, double a, double b, double lambda );


int		main( int ac, char* av[])
{
  WaveHeaderType	h;
  int		i, j;
  long	x;
  char	c;
  FILE*	fp;

  double lambda1 =  0.0000;    /* Sierpinski Gasketθͭ */
  double lambda2 = -0.1345;
  double lambda3 = -0.6086;
  double lambda4 = -0.6485;
  double lambda5 = -1.0565;
  double lambda6 = -1.3820;
  double lambda7 = -2.2271;
  double lambda8 = -2.2618;
  double lambda9 = -3.0000;
  double lambda10 = -3.6180;
  double lambda11 = -3.7362;
  double lambda12 = -4.0000;
  double lambda13 = -4.1820;
  double lambda14 = -4.7949;
  double lambda15 = -5.0000;
  double lambda16 = -5.1642;
  double lambda17 = -5.1856;
  double lambda18 = -6.0000;
 


  double a1 = 3.301;     /* ܲʬʬۡʰʲŬ*/
  double b1 = 3.156;
  double a2 = -10.077;
  double b2 = 3.536;
  double a3 = -10.00;
  double b3 = 4.025;
  double a4 = -6.077;
  double b4 = 10.134;
  double a5 = -7.212;
  double b5 = -10.675;
  double a6 = 9.017;
  double b6 = -7.166;
  double a7 = 6.020;
  double b7 = -6.121;
  double a8 = 10.4136;
  double b8 = 8.3145;
  double a9 = 5.1561;
  double b9 = 8.1442;
  double a10 = 10.3534;
  double b10 = -6.3513;
  double a11 = 6.3213;
  double b11 = 6.3572;
  double a12 = -6.3674;
  double b12 = 9.34567; 
  double a13 = 6.4473;
  double b13 = -10.6474;
  double a14 = -7.734;
  double b14 = -6.3513;
  double a15 = -6.3213;
  double b15 = -8.3572;
  double a16 = -7.3674;
  double b16 = 8.34567; 
  double a17 = 6.4473;
  double b17 = -10.6474;
  double a18 = 8.3534;
  double b18 = -8.3513;

  fp = fopen( "sierpinski_H3.wav", "wb" );
	
  InitHeader( &h );
	
  fwrite( &h, sizeof(h), 1, fp );
	

  /* 20 */
  for( i = 0; i < 176400*1; i++ ) {
	c = sierpinski( i, a1, b1, lambda1);
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*1; i < 176400*2; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 );
	fwrite( &c, sizeof(c), 1, fp );	
  }
  for (i = 176400*2; i < 176400*3; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*3; i < 176400*4; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*4; i < 176400*5; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*5; i < 176400*6; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*6; i < 176400*7; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*7; i < 176400*8; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*8; i < 176400*9; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*9; i < 176400*10; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*10; i < 176400*11; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 ) 
	  + sierpinski( i, a11, b11, lambda11 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*11; i < 176400*12; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 ) 
	  + sierpinski( i, a11, b11, lambda11 ) 
	  + sierpinski( i, a12, b12, lambda12 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*12; i < 176400*13; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 )
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 ) 
	  + sierpinski( i, a11, b11, lambda11 )
	  + sierpinski( i, a12, b12, lambda12 ) 
	  + sierpinski( i, a13, b13, lambda13 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*13; i < 176400*14; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 )
	  + sierpinski( i, a4, b4, lambda4 )
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 )
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 )
	  + sierpinski( i, a11, b11, lambda11 ) 
	  + sierpinski( i, a12, b12, lambda12 ) 
	  + sierpinski( i, a13, b13, lambda13 ) 
	  + sierpinski( i, a14, b14, lambda14 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*14; i < 176400*15; i++ ){
	c = sierpinski( i, a1, b1, lambda1 )
	  + sierpinski( i, a2, b2, lambda2 )
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 )
	  + sierpinski( i, a6, b6, lambda6 )
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 )
	  + sierpinski( i, a11, b11, lambda11 )
	  + sierpinski( i, a12, b12, lambda12 )
	  + sierpinski( i, a13, b13, lambda13 )
	  + sierpinski( i, a14, b14, lambda14 ) 
	  + sierpinski( i, a15, b15, lambda15 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*15; i < 176400*16; i++ ){
	c = sierpinski( i, a1, b1, lambda1 )
	  + sierpinski( i, a2, b2, lambda2 ) 
	  + sierpinski( i, a3, b3, lambda3 )
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 )
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 )
	  + sierpinski( i, a8, b8, lambda8 )
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 )
	  + sierpinski( i, a11, b11, lambda11 ) 
	  + sierpinski( i, a12, b12, lambda12 ) 
	  + sierpinski( i, a13, b13, lambda13 )
	  + sierpinski( i, a14, b14, lambda14 )
	  + sierpinski( i, a15, b15, lambda15 ) 
	  + sierpinski( i, a16, b16, lambda16 );
	fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*16; i < 176400*17; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 )
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 ) 
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 ) 
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 ) 
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 ) 
	  + sierpinski( i, a11, b11, lambda11 )
	  + sierpinski( i, a12, b12, lambda12 ) 
	  + sierpinski( i, a13, b13, lambda13 )
	  + sierpinski( i, a14, b14, lambda14 ) 
	  + sierpinski( i, a15, b15, lambda15 ) 
	  + sierpinski( i, a16, b16, lambda16 )
	  + sierpinski( i, a17, b17, lambda17 );								            fwrite( &c, sizeof(c), 1, fp );
  }
  for (i = 176400*17; i < 176400*20; i++ ){
	c = sierpinski( i, a1, b1, lambda1 ) 
	  + sierpinski( i, a2, b2, lambda2 )
	  + sierpinski( i, a3, b3, lambda3 ) 
	  + sierpinski( i, a4, b4, lambda4 )
	  + sierpinski( i, a5, b5, lambda5 ) 
	  + sierpinski( i, a6, b6, lambda6 )
	  + sierpinski( i, a7, b7, lambda7 ) 
	  + sierpinski( i, a8, b8, lambda8 )
	  + sierpinski( i, a9, b9, lambda9 ) 
	  + sierpinski( i, a10, b10, lambda10 )
	  + sierpinski( i, a11, b11, lambda11 )
	  + sierpinski( i, a12, b12, lambda12 )
	  + sierpinski( i, a13, b13, lambda13 )
	  + sierpinski( i, a14, b14, lambda14 )
	  + sierpinski( i, a15, b15, lambda15 )
	  + sierpinski( i, a16, b16, lambda16 )
	  + sierpinski( i, a17, b17, lambda17 )
	  + sierpinski( i, a18, b18, lambda18 );
	fwrite( &c, sizeof(c), 1, fp );
  }

  fclose( fp );
	
  return 0 ;
}

unsigned char sierpinski( int i, double a, double b, double lambda)
{
  int n;
  unsigned char f = 0;
  int v = 1000;           /* Ȥ® */
    

  f = a * sin( lambda * (double)(i / 176400.0) * v ) 
	+ b * cos(lambda * (double)(i / 176400.0) * v );

  return f;
}


/* Sierpinski_H3.c  end */
